<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@taglib prefix="sql" uri="http://java.sun.com/jsp/jstl/sql"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>

<c:if test="${!empty sessionScope.login}">
    <sql:query var="userProducts" dataSource="jdbc/projectecc">
        SELECT * FROM products WHERE login = ?
        <sql:param value="${sessionScope.login}"/>
    </sql:query>
</c:if>


<!DOCTYPE HTML>
<html lang="EN">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
        <title>Manage your Products</title>
        <link href="${initParam.css}styles.css" rel="stylesheet" type="text/css">
        <script src="${initParam.js}funciones.js"  type="text/javascript"> </script>
    </head>
    <body>
        <div class="contenedor">
            <header><a href="#"><img src="${initParam.imagePath}banner.jpg" alt="Banner" title="Banner" width="960" height="134" id="banner" /></a>
                <div id="bar">
                    <nav>
                        <ul>
                            <li><a href="index">Index</a></li>
                            <li><a href="login">Login/Logout</a></li>
                            <li><a href="register">Register</a></li>
                            <li><a href="addProducts">AddProducts</a></li>
                            <li><a class="active" href="#">ManageProducts</a></li>
                            <li><a href="doOrder">Orders</a></li>
                        </ul>
                    </nav>
                </div>
            </header>
            <div class="barraLateral">
                <aside>
                    <p class="destaca">Partners</p>
                    <ul id="partners">
                        <li><a href="#"><img src="${initParam.imagePath}logo000webhost.png" alt="Logo 000" title="WebFileHosting000" width="150" height="44" id="logo000"  /></a></li>
                        <li><a href="#"><img src="${initParam.imagePath}Logowebestilo.gif" alt="Logo WebEstilo" title="Logo WebEstilo" width="150" height="44" id="logoEstilo"/></a></li>
                    </ul>
                </aside>
                <!-- end .barra1--></div>
            <article class="content">
                <h1>Erase products</h1>
                <section>
                    <c:choose>
                        <c:when test="${!empty sessionScope.login}">
                            <h2>Delete Products Form for ${sessionScope.userName}</h2>
                            <c:choose><c:when test="${userProducts.rowCount!=0}">
                                    <div class="marginl15">
                                        <FORM name='fdelProducto' ACTION='delProducts' METHOD='post'>
                                            <TABLE class='tablaCompacta' id='delProductoTable'>
                                                <!-- column headers -->
                                                <tr>
                                                    <c:forEach var="columnName" items="${userProducts.columnNames}">
                                                        <th><c:out value="${columnName}"/></th>
                                                    </c:forEach>
                                                    <th>del?</th>
                                                </tr>
                                                <!-- column data -->
                                                <c:forEach var="product" items="${userProducts.rowsByIndex}" varStatus="iter">
                                                    <tr class="${((iter.index % 2) == 0) ? 'lightBlue' : 'white'}">
                                                        <c:forEach var="column" items="${product}">
                                                            <td><c:out value="${column}"/></td>
                                                        </c:forEach>
                                                        <c:choose>
                                                            <c:when test="${product[6] eq 'yes'}">
                                                                <TD><INPUT TYPE="CHECKBOX" NAME="borrar[]" VALUE="${product[0]}"</TD>
                                                                </c:when>
                                                                <c:otherwise>
                                                                <TD>N/A</TD>
                                                            </c:otherwise>
                                                        </c:choose>

                                                    </tr>
                                                </c:forEach>
                                            </TABLE>
                                            <BR>
                                            <c:choose>
                                                <c:when test="${sessionScope.availables eq true}">
                                                    <INPUT TYPE='SUBMIT' NAME='eliminar' VALUE='Delete products'>
                                                </c:when>
                                                <c:otherwise>You don't have products availables to delete</c:otherwise>
                                            </c:choose>
                                        </FORM>
                                    </div>
                                </c:when>
                                <c:otherwise><p>No products added</p>
                                </c:otherwise>
                            </c:choose>
                        </c:when>
                        <c:otherwise>
                            <h2>Data Form for registered users</h2>
                            <div class="marginl15">
                                <p>You are not looged, you have to login to access to your products</p>
                                <p>  <a href="login" >Go login</a></p>
                            </div>
                        </c:otherwise>
                    </c:choose>
                </section>
                <!-- end .content --></article>
            <footer>
                <address>
                    José Ángel García Fernández.<br>
                    Contact <a href="mailto:basic@gmail.com">basic@gmail.com</a>
                </address>
            </footer>
            <!-- end .contenedor --></div>
    </body>
</html>
