/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Noa
 */
@Entity
@Table(name = "orders")
@NamedQueries({
    @NamedQuery(name = "Orders.findAll", query = "SELECT o FROM Orders o"),
    @NamedQuery(name = "Orders.findByIdOrder", query = "SELECT o FROM Orders o WHERE o.idOrder = :idOrder"),
    @NamedQuery(name = "Orders.findByPriceFull", query = "SELECT o FROM Orders o WHERE o.priceFull = :priceFull"),
    @NamedQuery(name = "Orders.findByDateOrder", query = "SELECT o FROM Orders o WHERE o.dateOrder = :dateOrder"),
    @NamedQuery(name = "Orders.findByPaid", query = "SELECT o FROM Orders o WHERE o.paid = :paid"),
    @NamedQuery(name = "Orders.findByDelivered", query = "SELECT o FROM Orders o WHERE o.delivered = :delivered"),
    @NamedQuery(name = "Orders.findNotInProgress", query = "SELECT o FROM Orders o WHERE o.delivered = o.paid"),})
public class Orders implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "idOrder")
    private Long idOrder;
    @Basic(optional = false)
    @Column(name = "priceFull")
    private BigDecimal priceFull;
    @Basic(optional = false)
    @Column(name = "dateOrder")
    @Temporal(TemporalType.DATE)
    private Date dateOrder;
    @Basic(optional = false)
    @Column(name = "paid")
    private String paid;
    @Basic(optional = false)
    @Column(name = "delivered")
    private String delivered;
    @JoinColumn(name = "login", referencedColumnName = "login")
    @ManyToOne(optional = false)
    private Users users;
    @OneToMany(mappedBy = "orders")
    private Collection<Products> productsCollection;

    public Orders() {
    }

    public Orders(Long idOrder) {
        this.idOrder = idOrder;
    }

    public Orders(Long idOrder, BigDecimal priceFull, Date dateOrder, String paid, String delivered) {
        this.idOrder = idOrder;
        this.priceFull = priceFull;
        this.dateOrder = dateOrder;
        this.paid = paid;
        this.delivered = delivered;
    }

    public Long getIdOrder() {
        return idOrder;
    }

    public void setIdOrder(Long idOrder) {
        this.idOrder = idOrder;
    }

    public BigDecimal getPriceFull() {
        return priceFull;
    }

    public void setPriceFull(BigDecimal priceFull) {
        this.priceFull = priceFull;
    }

    public Date getDateOrder() {
        return dateOrder;
    }

    public void setDateOrder(Date dateOrder) {
        this.dateOrder = dateOrder;
    }

    public String getPaid() {
        return paid;
    }

    public void setPaid(String paid) {
        this.paid = paid;
    }

    public String getDelivered() {
        return delivered;
    }

    public void setDelivered(String delivered) {
        this.delivered = delivered;
    }

    public Users getUsers() {
        return users;
    }

    public void setUsers(Users users) {
        this.users = users;
    }

    public Collection<Products> getProductsCollection() {
        return productsCollection;
    }

    public void setProductsCollection(Collection<Products> productsCollection) {
        this.productsCollection = productsCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idOrder != null ? idOrder.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Orders)) {
            return false;
        }
        Orders other = (Orders) object;
        if ((this.idOrder == null && other.idOrder != null) || (this.idOrder != null && !this.idOrder.equals(other.idOrder))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entity.Orders[idOrder=" + idOrder + "]";
    }
}
