<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@taglib prefix="sql" uri="http://java.sun.com/jsp/jstl/sql"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>

<c:if test="${!empty sessionScope.login}">
    <sql:query var="userProducts" dataSource="jdbc/projectecc">
        SELECT * FROM products WHERE available="YES" AND login != ?
        <sql:param value="${sessionScope.login}"/>
    </sql:query>
    <sql:query var="userOrders" dataSource="jdbc/projectecc">
        SELECT * FROM orders WHERE login = ?
        <sql:param value="${sessionScope.login}"/>
    </sql:query>
    <sql:query var="userForOrders" dataSource="jdbc/projectecc">
        SELECT * FROM orders WHERE idOrder IN (
        SELECT idOrder FROM products where login = ?
        <sql:param value="${sessionScope.login}"/>)
    </sql:query>
</c:if>


<!DOCTYPE HTML>
<html lang="EN">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
        <title>Manage your Products</title>
        <link href="${initParam.css}styles.css" rel="stylesheet" type="text/css">
        <script src="${initParam.js}funciones.js"  type="text/javascript"> </script>
    </head>
    <body>
        <div class="contenedor">
            <header><a href="#"><img src="${initParam.imagePath}banner.jpg" alt="Banner" title="Banner" width="960" height="134" id="banner" /></a>
                <div id="bar">
                    <nav>
                        <ul>
                            <li><a href="index">Index</a></li>
                            <li><a href="login">Login/Logout</a></li>
                            <li><a href="register">Register</a></li>
                            <li><a href="addProducts">AddProducts</a></li>
                            <li><a href="manageProducts">ManageProducts</a></li>
                            <li><a class="active" href="#">Orders</a></li>
                        </ul>
                    </nav>
                </div>
            </header>
            <div class="barraLateral">
                <aside>
                    <p class="destaca">Partners</p>
                    <ul id="partners">
                        <li><a href="#"><img src="${initParam.imagePath}logo000webhost.png" alt="Logo 000" title="WebFileHosting000" width="150" height="44" id="logo000"  /></a></li>
                        <li><a href="#"><img src="${initParam.imagePath}Logowebestilo.gif" alt="Logo WebEstilo" title="Logo WebEstilo" width="150" height="44" id="logoEstilo"/></a></li>
                    </ul>
                </aside>
                <!-- end .barra1--></div>
            <article class="content">
                <h1>Orders</h1>
                <section>
                    <c:choose>
                        <c:when test="${!empty sessionScope.login}">
                            <h2>Do orders for ${sessionScope.userName}</h2>
                            <c:choose>
                                <c:when test="${userProducts.rowCount!=0}">
                                    <div class="marginl15">
                                        <FORM name='fdoOrder' ACTION='fdoOrder' METHOD='post'>
                                            <TABLE class='tablaCompacta' id='doOrderTable'>
                                                <!-- column headers -->
                                                <tr>
                                                    <c:forEach var="columnName" items="${userProducts.columnNames}">
                                                        <th><c:out value="${columnName}"/></th>
                                                    </c:forEach>
                                                    <th>Add?</th>
                                                </tr>
                                                <!-- column data -->
                                                <c:forEach var="product" items="${userProducts.rowsByIndex}" varStatus="iter">
                                                    <tr class="${((iter.index % 2) == 0) ? 'lightBlue' : 'white'}">
                                                        <c:forEach var="column" items="${product}">
                                                            <td><c:out value="${column}"/></td>
                                                        </c:forEach>
                                                        <TD><INPUT TYPE="CHECKBOX" NAME="order[]" VALUE="${product[0]}"</TD>
                                                    </tr>
                                                </c:forEach>
                                            </TABLE>
                                            <BR>
                                            <INPUT TYPE='SUBMIT' NAME='order' VALUE='Order products'>
                                        </FORM>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <p>No products availables</p>
                                </c:otherwise>
                            </c:choose>
                            <br>
                            <h2>Orders of ${sessionScope.userName}</h2>
                            <c:choose>
                                <c:when test="${userOrders.rowCount!=0}">
                                    <div class="marginl15">
                                        <FORM name='fdelOrder' ACTION='fdelOrder' METHOD='post'>
                                            <TABLE class='tablaCompacta' id='delOrderTable'>
                                                <!-- column headers -->
                                                <tr>
                                                    <c:forEach var="columnName" items="${userOrders.columnNames}">
                                                        <th><c:out value="${columnName}"/></th>
                                                    </c:forEach>
                                                    <th>Del?</th>
                                                </tr>
                                                <!-- column data -->
                                                <c:forEach var="order" items="${userOrders.rowsByIndex}" varStatus="iter">
                                                    <tr class="${((iter.index % 2) == 0) ? 'lightBlue' : 'white'}">
                                                        <c:forEach var="column" items="${order}">
                                                            <td><c:out value="${column}"/></td>
                                                        </c:forEach>
                                                        <c:choose>
                                                            <c:when test="${order[3] eq order[4]}">
                                                                <TD><INPUT TYPE="CHECKBOX" NAME="borrar[]" VALUE="${order[0]}"</TD>
                                                                </c:when>
                                                                <c:otherwise>
                                                                <TD>N/A</TD>
                                                            </c:otherwise>
                                                        </c:choose>

                                                    </tr>
                                                </c:forEach>
                                            </TABLE>
                                            <BR>
                                             <c:choose>
                                                <c:when test="${sessionScope.ordersNotInProgress eq true}">
                                                   <INPUT TYPE='SUBMIT' NAME='order' VALUE='Delete orders'>
                                                </c:when>
                                                <c:otherwise>You can't delete orders already in progress!</c:otherwise>
                                            </c:choose>
                                            
                                        </FORM>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <p>You did not do orders</p>
                                </c:otherwise>
                            </c:choose>
                            <br>
                            <h2>Orders for ${sessionScope.userName}</h2>
                            <c:choose>
                                <c:when test="${userForOrders.rowCount!=0}">
                                    <div class="marginl15">
                                        <FORM name='fchangeOrder' ACTION='fchangeOrder' METHOD='post'>
                                            <TABLE class='tablaCompacta' id='changeOrderTable'>
                                                <!-- column headers -->
                                                <tr>
                                                    <c:forEach var="columnName" items="${userForOrders.columnNames}">
                                                        <th><c:out value="${columnName}"/></th>
                                                    </c:forEach>
                                                    <th>Email</th>
                                                    <th>paid?</th>
                                                    <th>delivered?</th>
                                                </tr>
                                                <!-- column data -->
                                                <c:forEach var="order" items="${userForOrders.rowsByIndex}" varStatus="iter">
                                                    <tr class="${((iter.index % 2) == 0) ? 'lightBlue' : 'white'}">
                                                        <c:forEach var="column" items="${order}">
                                                            <td><c:out value="${column}"/></td>
                                                        </c:forEach>
                                                        <sql:query var="email" dataSource="jdbc/projectecc">
                                                            SELECT email FROM users where login = ?
                                                            <sql:param value="${order[5]}"/>
                                                        </sql:query>
                                                        <td><c:out value="${email.rows[0].email}"/></td>
                                                        <TD><INPUT TYPE="CHECKBOX" NAME="paid[]" VALUE="${order[0]}"</TD>
                                                        <TD><INPUT TYPE="CHECKBOX" NAME="deliver[]" VALUE="${order[0]}"</TD>
                                                    </tr>
                                                </c:forEach>
                                            </TABLE>
                                            <BR>
                                            <INPUT TYPE='SUBMIT' NAME='order' VALUE='Change orders'>
                                        </FORM>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <p>No orders for you</p>
                                </c:otherwise>
                            </c:choose>
                        </c:when>
                        <c:otherwise>
                            <h2>Data Form for registered users</h2>
                            <div class="marginl15">
                                <p>You are not looged, you have to login to access to orders functions</p>
                                <p>  <a href="login" >Go login</a></p>
                            </div>
                        </c:otherwise>
                    </c:choose>
                </section>
                <!-- end .content --></article>
            <footer>
                <address>
                    José Ángel García Fernández.<br>
                    Contact <a href="mailto:basic@gmail.com">basic@gmail.com</a>
                </address>
            </footer>
            <!-- end .contenedor --></div>
    </body>
</html>
